# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# Makefile Example to deploy TVM modules.
TVM_ROOT=$(shell cd ../..; pwd)
DMLC_CORE=${TVM_ROOT}/3rdparty/dmlc-core
ROCM_ROOT=/opt/dtk
OPENCV_INCLUDE = $(shell pkg-config --cflags opencv)
OPENCV_LIBS = $(shell pkg-config --libs opencv)

PKG_CFLAGS = -std=c++17 -O2 -fPIC\
	-I${TVM_ROOT}/include\
	-I${DMLC_CORE}/include\
	-I${ROCM_ROOT}/include\
	-I${OPENCV_INCLUDE}\
	-I${TVM_ROOT}/3rdparty/dlpack/include\
	-DDMLC_USE_LOGGING_LIBRARY=\<tvm/runtime/logging.h\>
	
PKG_LDFLAGS = -L${TVM_ROOT}/build -ldl -pthread\
	      -L${ROCM_ROOT}/lib -lamdhip64\
	      -L${OPENCV_LIBS}\
	      -L${ROCM_ROOT}/miopen/lib -lMIOpen\
	      -L${ROCM_ROOT}/rocblas/lib -lrocblas


.PHONY: clean all

all: lib/libtvm_runtime_pack.o lib/resnet50-v2_deploy lib/resnet50-v2-7.so

# Build rule for all in one TVM package library
.PHONY: lib/libtvm_runtime_pack.o
lib/libtvm_runtime_pack.o: tvm_runtime_pack.cc
	@mkdir -p $(@D)
	$(CXX) -c $(PKG_CFLAGS) -o $@  $^

# Deploy using the all in one TVM package library
.PHONY: lib/resnet50-v2_deploy
lib/resnet50-v2_deploy: resnet50-v2_deploy.cc lib/resnet50-v2-7.so lib/libtvm_runtime_pack.o
	@mkdir -p $(@D)
	$(CXX) $(PKG_CFLAGS) -o $@  $^ $(PKG_LDFLAGS)

clean:
	rm -rf lib
